# HG changeset patch
# User Remi Thebault <remi.thebault@gmail.com>
# Date 1607255478 -3600
#      Sun Dec 06 12:51:18 2020 +0100
# Node ID d6cea9acecdf869862b62e6599857c6cccb95d02
# Parent  95ec5841c9d6f52ce28c167a7d501078a4123965
Implementation of Property Inspector

HIGHLIGHTS

  * a widget with two main views
    - a tree to display and interact with graphics object tree
    - a table, displaying the properties of the object selected in the
      tree

  * the tree receive notifications of graphics object creation/deletion
    to update itself

  * the table provides display and edition of most types of properties


SHORTCOMINGS

  * Not all property types have yet proper editors/painting

  * Updating properties does not always reflect in the figures.
    - updating line color for example not always trigger redraw.
    - when redraw happens, all previous property editions are visible

  * Currently not usable outside the GUI. It is wished to have the PI usable
    from the terminal through the missing 'inspect' command.

DETAILED CHANGELOG

  * liboctave/util/oct-mutex.h
    - adding unique_lock template class that encapsulate a critical resource
      providing lock/unlock methods. unique_lock is moveable but non-copiable
      and also acts like a smart pointer.
      - not a strictly needed addition, but is used to provide safely the
        gh_manager instance to the GUI

  * libinterp/corefcn/graphics.in.h
    - adding some introspection of graphics properties
      - prop_type() method (returning new property_type enum)
      - as_base_property() method to retrieve a pointer that can be casted
      - as_[type]_property() that dynamic_cast the base property to derived
        type (not used - compiled out at the moment)

  * libinterp/corefcn/event-manager.h
    - adding lifetime events of graphics objects in the interpreter events
      interface. Needed to track creation and removal of graphics objects in
      the tree.

  * libinterp/corefcn/graphics.cc
   - fire the graphics objects lifetime events

  * libui/src/qt-interpreter-events.h
  * libui/src/qt-interpreter-events.cc
    - adding signals for the new graphics objects

  * libgui/src/interpreter-qobject.h
  * libgui/src/interpreter-qobject.cc
    - provide access to the gh_manager through a unique_lock
    - the GUI cannot use the gh_manager without locking it
    - Not very useful today because the gh_manager is not consistently locked
      in the interpreter thread (e.g. when setting/reading properties).
      This could lead to race conditions (although I didn't observe any).
    - May be a better strategy is to have fine grain (per property) locking.

  * libgui/src/item-hyperlink-delegate.h
  * libgui/src/item-hyperlink-delegate.cc
    - class that makes easy having hyperlinks in item models, without having
      to instantiate one widget per cell.

  * libgui/src/property-inspector.h
  * libgui/src/property-inspector.cc
    - implementation of the property inspector
      - simple widget that instantiate the more complex views and models and
        make them talk together

  * libgui/src/property-inspector-tree.h
  * libgui/src/property-inspector-tree.cc
    - implementation of the graphics handle tree model

  * libgui/src/property-inspector-table.h
  * libgui/src/property-inspector-table.cc
    - implementation of the graphics properties table model and item delegate.
    - to keep code flexible, I tried to take the best decisions based on the
      octave_value of the property rather than based on the derived property
      type, but this is not always possible. (hence the properties
      introspection)
    - there (at the moment) two specific widgets used as cell editors:
      - matrix_widget
      - color_editor_widget (this one use a *.ui designer file)

  * libgui/src/property-inspector-color-editor.ui
    - Qt Designer file for the color_editor_widget

  * libgui/src/main-window.h
  * libgui/src/main-window.cc
  * libgui/src/gui-preferences-sc.h
    - instantiate the property inspector and setup shortcuts

  * libgui/src/module.mk
    - adding new property inspector files

diff --git a/libgui/src/gui-preferences-all.h b/libgui/src/gui-preferences-all.h
--- a/libgui/src/gui-preferences-all.h
+++ b/libgui/src/gui-preferences-all.h
@@ -37,6 +37,7 @@
 #include "gui-preferences-mw.h"
 #include "gui-preferences-nr.h"
 #include "gui-preferences-pd.h"
+#include "gui-preferences-pi.h"
 #include "gui-preferences-ve.h"
 #include "gui-preferences-sc.h"
 #include "gui-preferences-sd.h"
diff --git a/libgui/src/gui-preferences-pi.h b/libgui/src/gui-preferences-pi.h
new file mode 100644
--- /dev/null
+++ b/libgui/src/gui-preferences-pi.h
@@ -0,0 +1,45 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2017-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if ! defined (octave_gui_preferences_pi_h)
+#define octave_gui_preferences_pi_h 1
+
+#include "gui-preferences.h"
+
+#include <QApplication>
+
+// Variable Editor preferences
+
+const gui_pref
+pi_tree_alternate_rows ("property_inspector/tree_alternate_rows", QVariant (false));
+
+const gui_pref
+pi_table_row_height ("property_inspector/table_row_height", QVariant ());
+
+const gui_pref
+pi_table_alternate_rows ("property_inspector/table_alternate_rows", QVariant (false));
+
+
+#endif // octave_gui_preferences_pi_h
diff --git a/libgui/src/gui-preferences-sc.h b/libgui/src/gui-preferences-sc.h
--- a/libgui/src/gui-preferences-sc.h
+++ b/libgui/src/gui-preferences-sc.h
@@ -112,6 +112,7 @@ const sc_pref sc_main_window_show_worksp
 const sc_pref sc_main_window_show_editor (sc_main_window + ":show_editor", PRE + CTRL_SHIFT + Qt::Key_4);
 const sc_pref sc_main_window_show_doc (sc_main_window + ":show_doc", PRE + CTRL_SHIFT + Qt::Key_5);
 const sc_pref sc_main_window_show_variable_editor (sc_main_window + ":show_variable_editor", PRE + CTRL_SHIFT + Qt::Key_6);
+const sc_pref sc_main_window_show_property_inspector (sc_main_window + ":show_property_inspector", PRE + CTRL_SHIFT + Qt::Key_7);
 const sc_pref sc_main_window_command (sc_main_window + ":command", PRE + CTRL + Qt::Key_0);
 const sc_pref sc_main_window_history (sc_main_window + ":history", PRE + CTRL + Qt::Key_1);
 const sc_pref sc_main_window_file_browser (sc_main_window + ":file_browser", PRE + CTRL + Qt::Key_2);
@@ -119,6 +120,7 @@ const sc_pref sc_main_window_workspace (
 const sc_pref sc_main_window_editor (sc_main_window + ":editor", PRE + CTRL + Qt::Key_4);
 const sc_pref sc_main_window_doc (sc_main_window + ":doc", PRE + CTRL + Qt::Key_5);
 const sc_pref sc_main_window_variable_editor (sc_main_window + ":variable_editor", PRE + CTRL + Qt::Key_6);
+const sc_pref sc_main_window_property_inspector (sc_main_window + ":property_inspector", PRE + CTRL + Qt::Key_7);
 const sc_pref sc_main_window_previous_dock (sc_main_window + ":previous_widget", PRE + CTRL_ALT + Qt::Key_P);
 const sc_pref sc_main_window_reset (sc_main_window + ":reset", QKeySequence::UnknownKey);
 
diff --git a/libgui/src/interpreter-qobject.cc b/libgui/src/interpreter-qobject.cc
--- a/libgui/src/interpreter-qobject.cc
+++ b/libgui/src/interpreter-qobject.cc
@@ -143,4 +143,13 @@ namespace octave
   {
     return m_octave_qobj.qt_link ();
   }
+
+  gh_manager_lock interpreter_qobject::get_gh_manager (void)
+  {
+    if (! m_interpreter)
+      throw std::logic_error ("interpreter_qobject::get_gh_manager called "
+                              "before initialization of interpreter");
+
+    return gh_manager_lock (m_interpreter->get_gh_manager ());
+  }
 }
diff --git a/libgui/src/interpreter-qobject.h b/libgui/src/interpreter-qobject.h
--- a/libgui/src/interpreter-qobject.h
+++ b/libgui/src/interpreter-qobject.h
@@ -28,14 +28,22 @@
 
 #include <QObject>
 
+#include "oct-mutex.h"
+
 #include "qt-interpreter-events.h"
 
+
+class gh_manager;
+
 namespace octave
 {
+
   class interpreter;
 
   class base_qobject;
 
+  using gh_manager_lock = ::octave::unique_lock<gh_manager>;
+
   class interpreter_qobject : public QObject
   {
     Q_OBJECT
@@ -52,6 +60,8 @@ namespace octave
 
     void interpreter_event (const meth_callback& meth);
 
+    gh_manager_lock get_gh_manager ();
+
   signals:
 
     void ready (void);
diff --git a/libgui/src/item-hyperlink-delegate.cc b/libgui/src/item-hyperlink-delegate.cc
new file mode 100644
--- /dev/null
+++ b/libgui/src/item-hyperlink-delegate.cc
@@ -0,0 +1,242 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if defined(HAVE_CONFIG_H)
+#include "config.h"
+#endif
+
+#include "item-hyperlink-delegate.h"
+
+#include <QAbstractItemModel>
+#include <QAbstractItemView>
+#include <QApplication>
+#include <QDesktopServices>
+#include <QFont>
+#include <QMouseEvent>
+#include <QPainter>
+#include <QSet>
+#include <QStyle>
+
+namespace octave
+{
+
+  constexpr int default_alignment = Qt::AlignCenter;
+
+  static const QColor unvisited_color = QColor (Qt::darkBlue).lighter();
+  static const QColor visited_color = QColor (Qt::darkMagenta);
+
+  static QSet<QUrl> visited_links;
+
+  static int item_alignment (const QModelIndex &index)
+  {
+    const auto model_alignment = index.data (Qt::TextAlignmentRole);
+    return model_alignment.isValid () ? model_alignment.toInt ()
+                                      : default_alignment;
+  }
+
+  item_hyperlink_delegate::item_hyperlink_delegate (QObject *parent,
+                                                    QAbstractItemView *view)
+      : QObject{ parent }, m_view{ view }, m_font_metrics{ QFont{} }
+  {
+  }
+
+  item_hyperlink_delegate::~item_hyperlink_delegate () = default;
+
+  void item_hyperlink_delegate::mouse_move_event (QMouseEvent *ev)
+  {
+    const auto *m = m_view->model ();
+    if (!m)
+      return;
+
+    if (m_clicked_hyperlink && !m_clicked_hl_rect.contains (ev->pos ()))
+      {
+        // handling mouse drag. Dragging out of hyperlink cancels the click
+        m_clicked_hyperlink = hyperlink{};
+        const auto ind = m_clicked_index;
+        m_clicked_index = QModelIndex{};
+        m_clicked_hl_rect = QRect{};
+
+        if (m_cursor_set)
+          {
+            m_view->setCursor (m_old_cursor);
+            m_cursor_set = false;
+          }
+
+        m_view->update (ind);
+        return;
+      }
+
+    const auto index = m_view->indexAt (ev->pos ());
+    if (!index.isValid ())
+      return;
+
+    const auto hl
+        = qvariant_cast<hyperlink> (m->data (index, Qt::DisplayRole));
+    if (hl.isEmpty ())
+      {
+        if (m_cursor_set)
+          {
+            m_view->setCursor (m_old_cursor);
+            m_cursor_set = false;
+          }
+        return;
+      }
+
+    const auto ir = m_view->visualRect (index);
+    const auto alignment = item_alignment (index);
+    const auto br = QApplication::style ()->itemTextRect (
+        m_font_metrics, ir, alignment, true, hl.title ());
+    const auto within = br.contains (ev->pos ());
+
+    if (within && !m_cursor_set)
+      {
+        m_old_cursor = m_view->cursor ();
+        m_view->setCursor (Qt::PointingHandCursor);
+        m_cursor_set = true;
+      }
+    else if (!within && m_cursor_set)
+      {
+        m_view->setCursor (m_old_cursor);
+        m_cursor_set = false;
+      }
+  }
+
+  bool item_hyperlink_delegate::mouse_press_event (QMouseEvent *ev)
+  {
+    const auto *m = m_view->model ();
+    if (!m)
+      return false;
+
+    const auto index = m_view->indexAt (ev->pos ());
+    if (!index.isValid ())
+      return false;
+
+    const auto hl
+        = qvariant_cast<hyperlink> (m->data (index, Qt::DisplayRole));
+    if (hl.isEmpty ())
+      return false;
+
+    const auto ir = m_view->visualRect (index);
+    const auto alignment = item_alignment (index);
+    const auto br = QApplication::style ()->itemTextRect (
+        m_font_metrics, ir, alignment, true, hl.title ());
+
+    if (br.contains (ev->pos ()))
+      {
+        m_click_pos = ev->pos ();
+        m_clicked_hyperlink = hl;
+        m_clicked_index = index;
+        m_clicked_hl_rect = br;
+        m_view->update (index);
+        return true;
+      }
+    return false;
+  }
+
+  void item_hyperlink_delegate::mouse_release_event (QMouseEvent *ev)
+  {
+    Q_UNUSED (ev)
+
+    if (m_clicked_hyperlink)
+      {
+        QDesktopServices::openUrl (m_clicked_hyperlink.url ());
+
+        visited_links.insert (m_clicked_hyperlink.url ());
+
+        m_clicked_hyperlink = hyperlink{};
+        const auto ind = m_clicked_index;
+        m_clicked_index = QModelIndex{};
+        m_clicked_hl_rect = QRect{};
+
+        m_view->update (ind);
+      }
+  }
+
+  QSize item_hyperlink_delegate::size_hint (const QStyleOptionViewItem &option,
+                                            const QModelIndex &index)
+  {
+    const auto hl = qvariant_cast<hyperlink> (index.data (Qt::DisplayRole));
+
+    if (hl.isEmpty ())
+      return QSize{};
+
+    if (!m_font_metrics_set)
+      {
+        set_font_metrics (option.fontMetrics);
+      }
+
+    return m_font_metrics.boundingRect (hl.title ()).size ();
+  }
+
+  void item_hyperlink_delegate::paint (QPainter *painter,
+                                       const QStyleOptionViewItem &option,
+                                       const QModelIndex &index)
+  {
+    const auto hl = qvariant_cast<hyperlink> (index.data (Qt::DisplayRole));
+
+    if (hl.isEmpty ())
+      return;
+
+    if (!m_font_metrics_set)
+      {
+        set_font_metrics (option.fontMetrics);
+      }
+
+    QFont font = option.font;
+    font.setUnderline (true);
+
+    QColor textColor = unvisited_color;
+    if (option.state.testFlag (QStyle::State_Selected))
+      {
+        // hard-code the color only if not highlighted
+        // (otherwise we can have blue over blue)
+        textColor = option.palette.color (QPalette::HighlightedText);
+      }
+    else if (visited_links.find (hl.url ()) != visited_links.end ())
+      {
+        textColor = visited_color;
+      }
+
+    const auto alignment = item_alignment (index);
+
+    auto rect = option.rect;
+
+    // animate the click
+    if (m_clicked_hyperlink)
+      {
+        rect.translate (QPoint (1, 2));
+      }
+
+    painter->save ();
+
+    painter->setFont (font);
+    painter->setPen (QPen (textColor, painter->pen ().widthF ()));
+
+    painter->drawText (option.rect, alignment, hl.title ());
+
+    painter->restore ();
+  }
+
+}
diff --git a/libgui/src/item-hyperlink-delegate.h b/libgui/src/item-hyperlink-delegate.h
new file mode 100644
--- /dev/null
+++ b/libgui/src/item-hyperlink-delegate.h
@@ -0,0 +1,150 @@
+////////////////////////////////////////////////////////////////////////
+//
+// Copyright (C) 2013-2020 The Octave Project Developers
+//
+// See the file COPYRIGHT.md in the top-level directory of this
+// distribution or <https://octave.org/copyright/>.
+//
+// This file is part of Octave.
+//
+// Octave is free software: you can redistribute it and/or modify it
+// under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Octave is distributed in the hope that it will be useful, but
+// WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Octave; see the file COPYING.  If not, see
+// <https://www.gnu.org/licenses/>.
+//
+////////////////////////////////////////////////////////////////////////
+
+#if !defined(octave_item_hyperlink_delegate_h)
+#define octave_item_hyperlink_delegate_h 1
+
+#include <QCursor>
+#include <QFontMetrics>
+#include <QModelIndex>
+#include <QObject>
+#include <QRect>
+#include <QString>
+#include <QStyleOptionViewItem>
+#include <QUrl>
+#include <QVariant>
+#include <Qt>
+
+class QAbstractItemView;
+class QMouseEvent;
+class QObject;
+class QPainter;
+
+namespace octave
+{
+  //! Describes an hyperlink, that is a url with a title
+  class hyperlink
+  {
+  public:
+    hyperlink (const QUrl &url, const QString &title)
+        : m_url{ url }, m_title{ title }
+    {
+    }
+    hyperlink (const QString &url, const QString &title)
+        : m_url{ url }, m_title{ title }
+    {
+    }
+
+    hyperlink () = default;
+    ~hyperlink () = default;
+    hyperlink (const hyperlink &) = default;
+    hyperlink &operator= (const hyperlink &) = default;
+
+    operator bool () const { return !isEmpty (); }
+
+    bool isEmpty () const { return m_url.isEmpty () || m_title.isEmpty (); }
+
+    QUrl url () const { return m_url; }
+    QString title () const { return m_title; }
+
+  private:
+    QUrl m_url;
+    QString m_title;
+  };
+
+  //! This class allows to easily setup hyperlinks in item
+  //! views (such as QTreeView or QTableView).
+  //!
+  //! There is no additional widget instanciated, so it is much more efficient
+  //! than having a QLabel in each cell.
+  //!
+  //! The usage requirements are as follow:
+  //! 1. The view must forward its mouse events to this delegate
+  //!    (and have mouse tracking set)
+  //! 2. For all indices with hyperlink, the model must return an hyperlink
+  //!    object in data() when role is Qt::DisplayRole.
+  //! 3. For all indices with hyperlink, the item delegate must forward
+  //!    sizeHint to this delegate
+  //! 4. For all indices with hyperlink, the item delegate must forward paint
+  //!    to this delegate
+  class item_hyperlink_delegate : public QObject
+  {
+    Q_OBJECT
+
+  public:
+    item_hyperlink_delegate (QObject *parent, QAbstractItemView *view);
+    virtual ~item_hyperlink_delegate ();
+
+    //! The QFontMetrics used by this delegate to paint and compute
+    //! bounding rects
+    QFontMetrics font_metrics () const { return m_font_metrics; }
+
+    //! Set the QFontMetrics used by this delegate.
+    //! Calling this method is entirely optional.
+    //! The delegate will use the style option item passed to paint
+    //! if this method is not called.
+    void set_font_metrics (const QFontMetrics &fm)
+    {
+      m_font_metrics = fm;
+      m_font_metrics_set = true;
+    }
+
+    //! View must call this method to forward mouse move event
+    //! (mouse tracking must be enabled in the view)
+    void mouse_move_event (QMouseEvent *ev);
+    //! View must call this method to forward mouse press event
+    //! Returns whether the hyperlink was hit by the click.
+    //! Item view may want to accept the event to avoid further
+    //! process (like selecting the row) if the hyperlink is hit
+    bool mouse_press_event (QMouseEvent *ev);
+    //! View must call this method to forward mouse release event
+    void mouse_release_event (QMouseEvent *ev);
+
+    //! View delegate must call this method to estimate size of the hyperlink.
+    QSize size_hint (const QStyleOptionViewItem &option,
+                     const QModelIndex &index);
+
+    //! View delegate must call this method to paint the hyperlink.
+    //! The hyperlink will be painted different color if link was visited.
+    void paint (QPainter *painter, const QStyleOptionViewItem &option,
+                const QModelIndex &index);
+
+  private:
+    QAbstractItemView *m_view = nullptr;
+    QCursor m_old_cursor;
+    bool m_cursor_set = false;
+    QFontMetrics m_font_metrics;
+    bool m_font_metrics_set = false;
+    QPoint m_click_pos;
+    hyperlink m_clicked_hyperlink;
+    QModelIndex m_clicked_index;
+    QRect m_clicked_hl_rect; // to test dragging out easily
+  };
+
+}
+
+Q_DECLARE_METATYPE (octave::hyperlink);
+
+#endif // octave_item_hyperlink_delegate_h
diff --git a/libgui/src/main-window.cc b/libgui/src/main-window.cc
--- a/libgui/src/main-window.cc
+++ b/libgui/src/main-window.cc
@@ -107,13 +107,13 @@ namespace octave
 #endif
   }
 
-  main_window::main_window (base_qobject& oct_qobj)
-    : QMainWindow (), m_octave_qobj (oct_qobj),
-      m_workspace_model (nullptr),
+  main_window::main_window (base_qobject &oct_qobj)
+    : QMainWindow (), m_octave_qobj (oct_qobj), m_workspace_model (nullptr),
       m_status_bar (nullptr), m_command_window (nullptr),
       m_history_window (nullptr), m_file_browser_window (nullptr),
       m_doc_browser_window (nullptr), m_editor_window (nullptr),
       m_workspace_window (nullptr), m_variable_editor_window (nullptr),
+      m_property_inspector_window (nullptr),
       m_external_editor (new external_editor_interface (this, m_octave_qobj)),
       m_active_editor (m_external_editor), m_settings_dlg (nullptr),
       m_find_files_dlg (nullptr), m_set_path_dlg (nullptr),
@@ -181,6 +181,7 @@ namespace octave
     m_editor_window = create_default_editor (this, m_octave_qobj);
     m_variable_editor_window = new variable_editor (this, m_octave_qobj);
     m_workspace_window = new workspace_view (this, m_octave_qobj);
+    m_property_inspector_window = new property_inspector (this, m_octave_qobj);
 
     m_previous_dock = m_command_window;
 
@@ -258,6 +259,7 @@ namespace octave
     delete m_history_window;
     delete m_status_bar;
     delete m_variable_editor_window;
+    delete m_property_inspector_window;
 
     delete m_find_files_dlg;
     delete m_release_notes_window;
@@ -2094,6 +2096,9 @@ namespace octave
              m_variable_editor_window, SLOT (save_settings (void)));
 
     connect (qApp, SIGNAL (aboutToQuit (void)),
+             m_property_inspector_window, SLOT (save_settings (void)));
+
+    connect (qApp, SIGNAL (aboutToQuit (void)),
              this, SLOT (prepare_to_exit (void)));
 
     connect (qApp, SIGNAL (focusChanged (QWidget*, QWidget*)),
@@ -2161,6 +2166,8 @@ namespace octave
 #endif
     addDockWidget (Qt::RightDockWidgetArea, m_variable_editor_window);
     tabifyDockWidget (m_command_window, m_variable_editor_window);
+    addDockWidget(Qt::RightDockWidgetArea, m_property_inspector_window);
+    tabifyDockWidget (m_command_window, m_property_inspector_window);
 
     addDockWidget (Qt::LeftDockWidgetArea, m_file_browser_window);
     addDockWidget (Qt::LeftDockWidgetArea, m_workspace_window);
@@ -2703,8 +2710,13 @@ namespace octave
     m_show_documentation_action = construct_window_menu_item
       (window_menu, tr ("Show Documentation"), true, m_doc_browser_window);
 
-    m_show_variable_editor_action = construct_window_menu_item
-      (window_menu, tr ("Show Variable Editor"), true, m_variable_editor_window);
+    m_show_variable_editor_action
+        = construct_window_menu_item (window_menu, tr ("Show Variable Editor"),
+                                      true, m_variable_editor_window);
+
+    m_show_property_inspector_action = construct_window_menu_item (
+        window_menu, tr ("Show Property Inspector"), true,
+        m_property_inspector_window);
 
     window_menu->addSeparator ();
 
@@ -2729,6 +2741,10 @@ namespace octave
     m_variable_editor_action = construct_window_menu_item
       (window_menu, tr ("Variable Editor"), false, m_variable_editor_window);
 
+    m_property_inspector_action
+        = construct_window_menu_item (window_menu, tr ("Property Inspector"),
+                                      false, m_property_inspector_window);
+
     window_menu->addSeparator ();
 
     m_previous_dock_action = add_action (window_menu, QIcon (),
@@ -2900,6 +2916,7 @@ namespace octave
     scmgr.set_shortcut (m_show_editor_action, sc_main_window_show_editor);
     scmgr.set_shortcut (m_show_documentation_action, sc_main_window_show_doc);
     scmgr.set_shortcut (m_show_variable_editor_action, sc_main_window_show_variable_editor);
+    scmgr.set_shortcut (m_show_property_inspector_action, sc_main_window_show_property_inspector);
     scmgr.set_shortcut (m_command_window_action, sc_main_window_command);
     scmgr.set_shortcut (m_history_action, sc_main_window_history);
     scmgr.set_shortcut (m_workspace_action, sc_main_window_workspace);
@@ -2907,6 +2924,7 @@ namespace octave
     scmgr.set_shortcut (m_editor_action, sc_main_window_editor);
     scmgr.set_shortcut (m_documentation_action, sc_main_window_doc);
     scmgr.set_shortcut (m_variable_editor_action, sc_main_window_variable_editor);
+    scmgr.set_shortcut (m_property_inspector_action, sc_main_window_property_inspector);
     scmgr.set_shortcut (m_previous_dock_action, sc_main_window_previous_dock);
     scmgr.set_shortcut (m_reset_windows_action, sc_main_window_reset);
 
@@ -2936,6 +2954,8 @@ namespace octave
 #endif
     list.append (static_cast<octave_dock_widget *> (m_workspace_window));
     list.append (static_cast<octave_dock_widget *> (m_variable_editor_window));
+    list.append (
+        static_cast<octave_dock_widget *> (m_property_inspector_window));
     return list;
   }
 
diff --git a/libgui/src/main-window.h b/libgui/src/main-window.h
--- a/libgui/src/main-window.h
+++ b/libgui/src/main-window.h
@@ -56,6 +56,7 @@
 #include "led-indicator.h"
 #include "octave-dock-widget.h"
 #include "octave-qobject.h"
+#include "property-inspector.h"
 #include "qt-interpreter-events.h"
 #include "set-path-dialog.h"
 #include "terminal-dock-widget.h"
@@ -331,6 +332,7 @@ namespace octave
     file_editor_interface *m_editor_window;
     workspace_view *m_workspace_window;
     variable_editor *m_variable_editor_window;
+    property_inspector *m_property_inspector_window;
     //!@}
 
     external_editor_interface *m_external_editor;
@@ -383,6 +385,7 @@ namespace octave
     QAction *m_show_editor_action;
     QAction *m_show_documentation_action;
     QAction *m_show_variable_editor_action;
+    QAction *m_show_property_inspector_action;
     QAction *m_command_window_action;
     QAction *m_history_action;
     QAction *m_workspace_action;
@@ -390,6 +393,7 @@ namespace octave
     QAction *m_editor_action;
     QAction *m_documentation_action;
     QAction *m_variable_editor_action;
+    QAction *m_property_inspector_action;
     QAction *m_previous_dock_action;
     QAction *m_reset_windows_action;
 
diff --git a/libgui/src/module.mk b/libgui/src/module.mk
--- a/libgui/src/module.mk
+++ b/libgui/src/module.mk
@@ -67,6 +67,8 @@ octave_gui_ICONS = \
   %reldir%/icons/graphic_logo_ReleaseWidget.svg \
   %reldir%/icons/graphic_logo_VariableEditor.svg \
   %reldir%/icons/hand2.png \
+  %reldir%/icons/hsplitter-handle.svg \
+  %reldir%/icons/hsplitter-handle.png \
   %reldir%/icons/icons_license \
   %reldir%/icons/left_side.png \
   %reldir%/icons/letter_logo_DocumentationDockWidget.png \
@@ -140,10 +142,14 @@ OCTAVE_GUI_SRC_MOC = \
   %reldir%/moc-gui-settings.cc \
   %reldir%/moc-history-dock-widget.cc \
   %reldir%/moc-interpreter-qobject.cc \
+  %reldir%/moc-item-hyperlink-delegate.cc \
   %reldir%/moc-led-indicator.cc \
   %reldir%/moc-main-window.cc \
   %reldir%/moc-news-reader.cc \
   %reldir%/moc-octave-qobject.cc \
+  %reldir%/moc-property-inspector.cc \
+  %reldir%/moc-property-inspector-table.cc \
+  %reldir%/moc-property-inspector-tree.cc \
   %reldir%/moc-settings-dialog.cc \
   %reldir%/moc-terminal-dock-widget.cc \
   %reldir%/moc-color-picker.cc \
@@ -174,6 +180,7 @@ DIRSTAMP_FILES += \
   %reldir%/$(octave_dirstamp)
 
 octave_gui_UI = \
+  %reldir%/property-inspector-color-editor.ui \
   %reldir%/settings-dialog.ui
 
 octave_gui_UI_H = $(patsubst %reldir%/%.ui, %reldir%/ui-%.h, $(octave_gui_UI))
@@ -200,6 +207,7 @@ noinst_HEADERS += \
   %reldir%/gui-preferences-mw.h \
   %reldir%/gui-preferences-nr.h \
   %reldir%/gui-preferences-pd.h \
+  %reldir%/gui-preferences-pi.h \
   %reldir%/gui-preferences-sc.h \
   %reldir%/gui-preferences-sd.h \
   %reldir%/gui-preferences-ve.h \
@@ -211,6 +219,7 @@ noinst_HEADERS += \
   %reldir%/graphics-init.h \
   %reldir%/history-dock-widget.h \
   %reldir%/interpreter-qobject.h \
+  %reldir%/item-hyperlink-delegate.h \
   %reldir%/led-indicator.h \
   %reldir%/m-editor/file-editor-interface.h \
   %reldir%/m-editor/file-editor-tab.h \
@@ -222,6 +231,9 @@ noinst_HEADERS += \
   %reldir%/main-window.h \
   %reldir%/news-reader.h \
   %reldir%/octave-qobject.h \
+  %reldir%/property-inspector.h \
+  %reldir%/property-inspector-table.h \
+  %reldir%/property-inspector-tree.h \
   %reldir%/qt-application.h \
   %reldir%/qt-interpreter-events.h \
   %reldir%/qt-utils.h \
@@ -253,6 +265,7 @@ noinst_HEADERS += \
   %reldir%/gui-settings.cc \
   %reldir%/history-dock-widget.cc \
   %reldir%/interpreter-qobject.cc \
+  %reldir%/item-hyperlink-delegate.cc \
   %reldir%/led-indicator.cc \
   %reldir%/m-editor/file-editor-tab.cc \
   %reldir%/m-editor/file-editor.cc \
@@ -264,6 +277,9 @@ noinst_HEADERS += \
   %reldir%/news-reader.cc \
   %reldir%/octave-dock-widget.cc \
   %reldir%/octave-qobject.cc \
+  %reldir%/property-inspector.cc \
+  %reldir%/property-inspector-table.cc \
+  %reldir%/property-inspector-tree.cc \
   %reldir%/qt-interpreter-events.cc \
   %reldir%/qt-application.cc \
   %reldir%/resource-manager.cc \
